
--[[
Fog sample using the Mesh Api.
Mells.
]]--



-- Set variables
-- --------------------------
local w, h = application:getContentWidth(), application:getContentHeight()
local centerX, centerY = w*.5, h*.5






				
-- ----------------------------------
-- Create Image
-- ----------------------------------
local texture = Texture.new("img_fuji.jpg")
local fuji = Bitmap.new(texture)
fuji:setAnchorPoint(.5, .5)


-- Stretch image horizontally
local newScale = w/fuji:getWidth()
fuji:setScale(newScale, newScale)
fuji:setPosition(centerX, centerY)
stage:addChild(fuji)


-- ----------------------------------
-- Create Fog's mesh
-- ----------------------------------
	local bg = Sprite.new()
	bg:setAnchorPoint(.5, .5)
	bg:setPosition(w*.5, h*.5)
	bg:setBlendMode("add")
	stage:addChild(bg)
	
	-- Create a new mesh object
	local mesh = Mesh.new()
	bg:addChild(mesh)
 
	-- set Vertices
	mesh:setVertices(
                1, -w*.5, -h*.5,
				2, w*.5, -h*.5,
				3, -w*.5, -h*.25,
				4, w*.5, -h*.25,					
				5, -w*.5, h*.5,
				6, w*.5, h*.5					
			    )
 
	-- set Indices
	mesh:setIndexArray(	
                1, 2, 3,
				2, 4, 3,
				3, 4, 5,
				4, 5, 6
				
				)
 
	-- set Colors
	mesh:setColorArray(	
				0x000000, 1, 0x000000, 1,
				0x000000, 1, 0x000000, 1,
				0x000000, 1, 0x000000, 1		
				)
				
				
				
				
-- ----------------------------------
-- Create Fog
-- ----------------------------------
local fog1 = Sprite.new()
fog1:setAnchorPoint(.5, 1)

local fogW, fogH = fuji:getWidth()*3, fuji:getHeight()


-- ----------------------------------
-- Create Fog's mesh
-- ----------------------------------
 
	-- Create a new mesh object
	local mesh = Mesh.new()
	fog1:addChild(mesh)
 
	-- set Vertices
	mesh:setVertices(
                1, -fogW*.5, -fogH*.5,
				2, fogW*.5, -fogH*.5,
				3, -fogW*.5, -fogH*.25,
				4, fogW*.5, -fogH*.25,					
				5, -fogW*.5, fogH*.5,
				6, fogW*.5, fogH*.5					
			    )
 
	-- set Indices
	mesh:setIndexArray(	
                1, 2, 3,
				2, 4, 3,
				3, 4, 5,
				4, 5, 6
				
				)
 
	-- set Colors
	mesh:setColorArray(	
				0xed8642, 1, 0xFF0000, 1,
				0xFFFFFF, 1, 0xFFFFFF, 1,
				0x000000, .3, 0x000000, .4				
				)
				
	-- add a texture
	local meshTexture = Texture.new("img_clouds.jpg", false, {wrap = Texture.REPEAT})
	local textW, textH = meshTexture:getWidth(), meshTexture:getHeight()
	mesh:setTexture(meshTexture)
	
	
	mesh:setTextureCoordinates(
							1, 0, 0,
							2, textW, 0,
							3, 0, textH*.5,
							4, textW, textH*.5,
							5, 0, textH,
							6, textW, textH
							)
							
							
	-- ------------
	-- Position Fog
	--- -------------
	fog1:setPosition(centerX, centerY)
	fog1:setBlendMode("screen")
	GTween.new(fog1, 30, {x = fog1:getX() *2}, {setLoop = true, reflect = true, repeatCount = 0})

	
-- ----------------------------------
-- Create Fog
-- ----------------------------------
local fog2 = Sprite.new()
fog2:setAnchorPoint(.5, 1)

stage:addChild(fog1)
stage:addChild(fog2)

	-- ----------------------------------
	-- Create Fog's mesh
	-- ----------------------------------
 
	fogW, fogH = fuji:getWidth()*3, fuji:getHeight()*.5
	-- Create a new mesh object
	mesh = Mesh.new()
	fog2:addChild(mesh)
 
	-- set Vertices
	mesh:setVertices(
                1, -fogW*.5, -fogH*.5,
				2, fogW*.5, -fogH*.5,
				3, -fogW*.5, -fogH*.25,
				4, fogW*.5, -fogH*.25,					
				5, -fogW*.5, fogH*.5,
				6, fogW*.5, fogH*.5					
			    )
 
	-- set Indices
	mesh:setIndexArray(	
                1, 2, 3,
				2, 4, 3,
				3, 4, 5,
				4, 5, 6
				
				)
 
	-- set Colors
	mesh:setColorArray(
				0x000000, .1, 0x000000, .1,
				0xFFFFFF, 1, 0xFFFFFF, 1,
				0x000000, .3, 0x000000, .4							
				)
				
	-- add a texture
	local meshTexture = Texture.new("img_clouds.jpg", false, {wrap = Texture.REPEAT})
	local textW, textH = meshTexture:getWidth(), meshTexture:getHeight()
	mesh:setTexture(meshTexture)
	
	
	mesh:setTextureCoordinates(
							1, 0, 0,
							2, textW, 0,
							3, 0, textH*.5,
							4, textW, textH*.5,
							5, 0, textH,
							6, textW, textH
							)
							
							
	-- ------------
	-- Position Fog
	--- -------------
	fog2:setPosition(centerX, centerY)
	fog2:setBlendMode("screen")
	GTween.new(fog2, 30, {x = fog2:getX() *-1}, {setLoop = true, reflect = true, repeatCount = 0})



